# Tutorial

This tutorial will walk you through writing a Jepsen test from scratch. It is
also the basis for a [training class](https://jepsen.io/training) offered by
Jepsen.

If you aren't familiar with the Clojure language, we recommend you start with
[Clojure for the Brave and True](http://www.braveclojure.com/), [Clojure From
the Ground Up](https://aphyr.com/posts/301-clojure-from-the-ground-up-welcome),
or any guide that works for you.

1. [Test Scaffolding](01-scaffolding.md)
2. [Database Automation](02-db.md)
3. [Writing a Client](03-client.md)
4. [Checking Correctness](04-checker.md)
5. [Introducing Faults](05-nemesis.md)
6. [Refining Tests](06-refining.md)
7. [Tuning with Parameters](07-parameters.md)
8. [Adding a Set Test](08-set.md)
